<?php

declare(strict_types=1);

namespace SimAVRPHP\Opcode;

class BRNE extends Instruction
{
    public const string OPCODE = "111101kkkkkkk001";

    public const int WORDS = 1;

    public function do(int $k): void
    {
        $k = Instruction::signed($k, -64, 63);
        $this->debug('Branch if Not Equal: ' . $k);
        $return_address = $this->mcu->pc->get() + (self::WORDS << 1);
        $this->mcu->stack->push($return_address);

        $newPC = $this->mcu->pc->get();
        if ($this->mcu->registers->getZ()) {
            $newPC += (self::WORDS << 1);
        } else {
            $newPC += ($k << 1) + 2;
        }

        $this->mcu->pc->jump($newPC);
    }
}
