<?php

declare(strict_types=1);

namespace SimAVRPHP\Opcode;

class CALL extends Instruction
{
    public const string OPCODE = "1001010kkkkk111kkkkkkkkkkkkkkkkk";

    public const int WORDS = 2;

    public const int CYCLES = 4;

    public function do(int $k): void
    {
        $this->debug("Call", ['k' => $k]);
        $return_address = $this->mcu->pc->get() + (self::WORDS << 1);
        $this->mcu->stack->push($return_address);
        $this->mcu->pc->jump($k << 1);
    }
}
