<?php

declare(strict_types=1);

namespace SimAVRPHP\Opcode;

class EOR extends Instruction
{
    public const string OPCODE = "001001rdddddrrrr";

    public const int WORDS = 1;

    public const int CYCLES = 1;

    public function do(int $r, int $d): void
    {
        $Rd = $this->mcu->registers->get($d);
        $Rr = $this->mcu->registers->get($r);

        $result = $Rd ^ $Rr;

        $this->mcu->registers->set($d, $result);
        $this->debug(sprintf('Exclusive OR: %d xor %d = %d', $Rd, $Rr, $result));
        $this->mcu->pc->stepWords(self::WORDS);
    }
}
