<?php

declare(strict_types=1);

namespace SimAVRPHP\Opcode;

class LDI extends Instruction
{
    public const string OPCODE = "1110KKKKddddKKKK";

    public const int WORDS = 1;

    public const int CYCLES = 1;


    public function do(int $K, int $d): void
    {
        $reg = $d + 16;
        $this->mcu->registers->set($reg, $K);
        $this->debug(sprintf('Load Immediate: %d to R%d', $K, $reg));
        $this->mcu->pc->stepWords(self::WORDS);
    }
}
