<?php

declare(strict_types=1);

namespace SimAVRPHP\Opcode;

class OUT extends Instruction
{
    public const string OPCODE = "10111AArrrrrAAAA";

    public const int WORDS = 1;

    public const int CYCLES = 1;


    public function do(int $r, int $A): void
    {
        $Rr = $this->mcu->registers->get($r);

        $this->debug(sprintf('OUT: R%d Value %d to A: %d', $r, $Rr, $A));
        $this->mcu->registers->setA($A, $Rr);
        $this->mcu->pc->stepWords(self::WORDS);
    }
}
