<?php

declare(strict_types=1);

namespace SimAVRPHP\Opcode;

class RJMP extends Instruction
{
    public const string OPCODE = "1100kkkkkkkkkkkk";

    public const int WORDS = 1;

    public const int CYCLES = 2;

    public function do(int $k): void
    {
        $k = $this->signed($k, -2048, 2047);
        $new_pc = $this->mcu->pc->get() + ($k * 2) + 2;
        $this->debug("Relative Jump to: " . sprintf("0x%X", $new_pc));

        $this->mcu->pc->jump($new_pc);
    }
}
