<?php

declare(strict_types=1);

namespace SimAVRPHP\Opcode;

class SUBI extends Instruction
{
    public const string OPCODE = "0101KKKKddddKKKK";

    public const int WORDS = 1;

    public const int CYCLES = 1;


    public function do(int $K, int $d): void
    {
        $reg = $d + 16;
        $value = $this->mcu->registers->get($reg);
        $result = $value - $K;
        $this->mcu->registers->set($reg, $result);
        $this->debug("Subtract Immediate: R" . $reg . " - " . $K);
        $this->mcu->pc->stepWords(self::WORDS);
    }
}
