<?php

declare(strict_types=1);

namespace SimAVRPHP;

class Registers
{
    private bool $Z = FALSE;

    private bool $I = FALSE;

    /**
     * @var int[]
     */
    private $registers = [];

    /**
     * @var int[]
     */
    private $A = [];

    public function __construct()
    {
        $this->reset();
    }

    public function reset(): void
    {
        $this->Z = FALSE;
        $this->I = FALSE;
        $this->registers = [0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0];
    }

    public function get(int $i): int
    {
        return $this->registers[$i];
    }

    public function set(int $i, int $value): void
    {
        $this->registers[$i] = $value;
    }

    public function setA(int $A, int $value): void
    {
        $this->A[$A] = $value;
    }

    public function getA(int $A): int
    {
        return $this->A[$A];
    }

    public function getZ(): bool
    {
        return $this->Z;
    }

    public function setI(bool $I): void
    {
        $this->$I = $I;
    }

    public function getI(): bool
    {
        return $this->I;
    }
}
