<?php

declare(strict_types=1);

namespace SimAVRPHP;

use Exception;

class Stack
{
    /**
     * @var int[]
     */
    private array $stack = [];

    public function reset(): void
    {
        $this->stack = [];
    }

    public function push(int $value): void
    {
        $this->stack[] = $value;
    }

    public function pop(): int
    {
        if (count($this->stack) >= 1) {
            return array_pop($this->stack);
        }

        throw new Exception("Stack Underflow");
    }
}
