<?php

declare(strict_types=1);

namespace SimAVRPHP\Tests;

use SimAVRPHP\ProgramCounter;
use SimAVRPHP\Exceptions\InvalidAddressException;

use PHPUnit\Framework\TestCase;
use PHPUnit\Framework\Attributes\CoversClass;


#[CoversClass(ProgramCounter::class)]
class ProgramCounterTest extends TestCase
{
    public function testStepAndSet(): void
    {
        $pc = new ProgramCounter();
        $this->assertEquals(0, $pc->get());

        $pc->stepWords(1); //Step 1 word

        $this->assertEquals(2, $pc->get());

        $pc->jump(0x100);
        $this->assertEquals(0x100, $pc->get());

        $pc->reset();
        $this->assertEquals(0, $pc->get());
    }

    public function testSetinvalid(): void
    {
        $pc = new ProgramCounter();
        $this->expectException(InvalidAddressException::class);
        $pc->jump(3); //Uneven address
    }

}
